"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var recompose_1 = require("recompose");
var Helpers_1 = require("../Helpers");
var WithLoadingIndicator_1 = require("../WithLoadingIndicator");
var WithModelFormBody_1 = require("./WithModelFormBody");
var Form = function (_a) {
    var children = _a.children, props = __rest(_a, ["children"]);
    return (React.createElement("form", __assign({ noValidate: true }, props), children));
};
exports.ModelForm = recompose_1.compose(recompose_1.setDisplayName("ModelForm"), recompose_1.defaultProps({
    formComponent: Form,
    readOnly: false
}), recompose_1.withHandlers({
    onSubmit: function (props) { return function (e) {
        e.preventDefault();
        var model = props.model, onSave = props.onSave, onError = props.onError;
        model
            .save()
            .then(onSave, onError);
    }; },
    onReset: function (props) { return function (e) {
        e.preventDefault();
        var model = props.model, onCancel = props.onCancel;
        model.reset();
        if (onCancel) {
            onCancel();
        }
    }; },
}), WithLoadingIndicator_1.withLoadingIndicator({ isLoading: function (_a) {
        var model = _a.model;
        return model == null;
    } }), WithModelFormBody_1.withModelFormBody(), Helpers_1.omitProps(["model", "onCancel", "onError", "onSave"]))(function (_a) {
    var FormComponent = _a.formComponent, props = __rest(_a, ["formComponent"]);
    return React.createElement(FormComponent, __assign({}, props));
});
